#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "spinsubs.h"

#ifdef CSPIN_FLAG
#define SEEK_SET 0
#define fseek c_fseek
#define exit c_exit
#define FILE long
#endif

#define DOUBLE_QUOTE 0x22
#define SINGLE_QUOTE 0x27
#define TAB   9
#define OBJECT_OFFSET 16

int checksum = 0;
int pc = 0;
int pc0 = 0;
FILE *outfile;
int listflag = 0;
int numsym = 0;

#if 0
typedef struct symbolS {
    char *name;
    int value;
    int type;
    int size;
    int array;
} symbolT;
#endif

char bigbuf[8000];
symbolT symbol[200];
char buffer1[100];
char *bigptr = bigbuf;

void SetSymbolSize(int index, int size)
{
    if (index < 0 || index >= numsym) return;
    //printf("SetSymbolSize: %d %s %d\n", index, symbol[index].name, size);
    symbol[index].size = size;
}

void SetSymbolArray(int index, int array)
{
    if (index < 0 || index >= numsym) return;
    //printf("SetSymbolArray: %d %s %d\n", index, symbol[index].name, array);
    symbol[index].array = array;
}

void IncrSymbolArray(int index)
{
    if (index < 0 || index >= numsym) return;
    //printf("IncrSymbolArray: %d %s %d\n", index, symbol[index].name, symbol[index].array);
    symbol[index].array++;
}

int GetSymbolSize(int index)
{
    if (index < 0 || index >= numsym) return 0;
    //printf("GetSymbolSize: %d %s %d\n", index, symbol[index].name, symbol[index].size);
    return symbol[index].size;
}

int GetSymbolArray(int index)
{
    if (index < 0 || index >= numsym) return 0;
    //printf("GetSymbolArray: %d %s %d\n", index, symbol[index].name, symbol[index].array);
    return symbol[index].array;
}

int GetSymbolType(int index)
{
    if (index < 0 || index >= numsym) return 0;
    return symbol[index].type;
}

int FindSymbol(char *str)
{
    int i;

    for (i = 0; i <numsym; i++)
    {
	if (symbol[i].type == 0) continue;
	if (StrCompNoCase(symbol[i].name, str) == 0) break;
    }
    //if (i < numsym) printf("FindSymbol: %s %d %s\n", str, i, symbol[i].name);
    if (i < numsym) return i;
    //printf("FindSymbol: %s -1\n", str);
    return -1;
}

int GetSymbolValue(char *str, int pass)
{
    int i;

    if (pass == 1)
        return 0;

    for (i = 0; i < numsym; i++)
    {
	if (symbol[i].type == 0) continue;
	if (strcmp(symbol[i].name, str) == 0) break;
    }
    if (i < numsym)
        return symbol[i].value;

    if (pass == 0) return 0;

    printf("%s is undefined\n", str);
    exit(1);

    return 0;
}

char *CopyString(char *str)
{
    char *ptr = bigptr;
    strcpy(bigptr, str);
    bigptr += strlen(bigptr) + 1;
    return ptr;
}

int AddSymbol(char *str, int value, int type)
{
    int i;

    //printf("AddSymbol: %s, %x, %d\n", str, value, type);

    for (i = 0; i < numsym; i++)
    {
	if (symbol[i].type == 0) break;
    }
    strcpy(bigptr, str);
    //printf("Adding to position %d\n", i);
    symbol[i].name = bigptr;
    symbol[i].value = value;
    symbol[i].type = type;
    symbol[i].size = 0;
    symbol[i].array = 0;
    bigptr += strlen(bigptr) + 1;
    if (i == numsym) numsym++;
    return i;
}

void RemoveLocalSymbols(void)
{
    int i;

    for (i = 0; i < numsym; i++)
    {
	if (symbol[i].type == TYPE_LOCAL)
	    symbol[i].type = 0;
    }
}

void PrintSymbolTable(void)
{
    int i;
    printf("\nSymbol Table\n");
    for (i = 0; i < numsym; i++)
    {
	if (symbol[i].type == 0) continue;
        printf("%s $%x (%d) %d\n",
	    symbol[i].name, symbol[i].value, symbol[i].value, symbol[i].type);
    }
}

void AddStandardSymbols(void)
{
    AddSymbol("par", 0x1f0, TYPE_CONSTANT);
    AddSymbol("cnt", 0x1f1, TYPE_CONSTANT);
    AddSymbol("ina", 0x1f2, TYPE_CONSTANT);
    AddSymbol("inb", 0x1f3, TYPE_CONSTANT);
    AddSymbol("outa", 0x1f4, TYPE_CONSTANT);
    AddSymbol("outb", 0x1f5, TYPE_CONSTANT);
    AddSymbol("dira", 0x1f6, TYPE_CONSTANT);
    AddSymbol("dirb", 0x1f7, TYPE_CONSTANT);
    AddSymbol("ctra", 0x1f8, TYPE_CONSTANT);
    AddSymbol("ctrb", 0x1f9, TYPE_CONSTANT);
    AddSymbol("frqa", 0x1fa, TYPE_CONSTANT);
    AddSymbol("frqb", 0x1fb, TYPE_CONSTANT);
    AddSymbol("phsa", 0x1fc, TYPE_CONSTANT);
    AddSymbol("phsb", 0x1fd, TYPE_CONSTANT);
    AddSymbol("vcfg", 0x1fe, TYPE_CONSTANT);
    AddSymbol("vscl", 0x1ff, TYPE_CONSTANT);
    AddSymbol("result", 0, TYPE_CONSTANT);
    AddSymbol("xtal1_pll16x", 0x6f, TYPE_CONSTANT);
}
